package ch.zhaw.pm2.racetrack.strategy;

import ch.zhaw.pm2.racetrack.PositionVector.Direction;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class MoveListStrategy implements MoveStrategy {

    private List<Direction> moveList;
    private int pointer;

    public MoveListStrategy(String path) throws FileNotFoundException{
        moveList = new ArrayList<>();
        pointer = -1;
        readFile(new File(path));
    }

    private void readFile(File trackFile) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream(trackFile), "UTF-8");
        Direction[] directions = Direction.values();
        while (scanner.hasNextLine()) {
            String line = scanner.nextLine();
            for (Direction direction : directions) {
                if (direction.toString().equals(line)) {
                    moveList.add(direction);
                    break;
                }
            }
        }
    }

    @Override
    public Direction nextMove() {
        pointer += 1;
        if (pointer < moveList.size()) {
            return moveList.get(pointer);
        }
        return null;
    }
}
